<template>
  <div>
    <Header :loggedIn="loggedIn" :auth="auth">
      <h1 class="header--hero--title">Register</h1>
    </Header>
    <Container>
      <div class="register-box">
        <div class="register-box--header">
          Register
        </div>
        <form @submit="formSubmit" class="register-box--form">
          <div class="register-box--form--row">
            <label class="register-box--label">
              Username:
              <input class="register-box--text-input" @keydown="inputChange('username')" type="text" v-model="username">
            </label>
            <div v-if="errors['username']" class="register-box--error">
              {{ errors['username'] }}
            </div>
          </div>
          <div class="register-box--form--row">
            <label class="register-box--label">
              Email:
              <input class="register-box--text-input" @keydown="inputChange('email')" type="text" v-model="email">
            </label>
            <div v-if="errors['email']" class="register-box--error">
              {{ errors['email'] }}
            </div>
          </div>
          <div class="register-box--form--row">
            <label class="register-box--label">
              Password:
              <input class="register-box--text-input" @keydown="inputChange('password')" type="password" v-model="password">
            </label>
            <div v-if="errors['password']" class="register-box--error">
              {{ errors['password'] }}
            </div>
          </div>
          <div class="register-box--form--row">
            <label class="register-box--label">
              Password Repeat:
              <input class="register-box--text-input" @keydown="inputChange('passwordRepeat')" type="password" v-model="passwordRepeat">
            </label>
            <div v-if="errors['passwordRepeat']" class="register-box--error">
              {{ errors['passwordRepeat'] }}
            </div>
          </div>
          <div class="register-box--form--row register-box--form--row-actions">
            <button type="submit" class="button">
              {{ !registering ? "Register" : "Registering ..." }}
            </button>
          </div>
          <div class="register-box--form--row">
            <router-link to="/login">Already have an account? login</router-link>
          </div>
        </form>
      </div>
    </Container>
  </div>
</template>

<script>
import Header from '../components/Header';
import Container from '../components/Container';
import { error } from 'util';

export default {
  name: 'register',
  components: {
    Header: Header,
    Container: Container
  },
  props: ['auth'],
  data: function(){
    return {
      registering: false,
      username: '',
      email: '',
      password: '',
      passwordRepeat: '',
      errors: {},
      loggedIn: (this.auth.currentUser ? true : false)
    }
  },
  methods: {
    formSubmit: function(e){
      e.preventDefault();
      if(this.registering){
        return;
      }
      let valid = this.validate();
      if(valid){
        this.registering = true;
        let user = {
          username: this.username,
          email: this.email,
          password: this.password
        };
        this.auth.register(user)
        .then((result) => {
          this.registering = false;
          this.$router.replace("/");
        })
        .catch((err) => {
          this.registering = false;
          if(err && err.errors){
            this.errors = err.errors;
          } else {
            this.formError = "An error has occured.";
          }
        });
      }
    },
    validate: function(){
      let valid = true;
      let errors = {};
      
      this.errors = {};

      if(!this.username){
        errors['username'] = 'This field is required';
        valid = false;
      }
      if(!this.email){
        errors['email'] = 'This field is required';
        valid = false;
      }
      if(!this.password){
        errors['password'] = 'This field is required';
        valid = false;
      }
      if(this.password && !this.passwordRepeat){
        errors['passwordRepeat'] = 'Please repeat your password';
        valid = false;
      }
      else if(this.password && this.passwordRepeat != this.password){
        errors['passwordRepeat'] = "passwords don't match";
        valid = false;
      }
      this.errors = errors;
      return valid;
    },
    inputChange: function(fieldName){
      let errors = { ...this.errors };
      errors[fieldName] = '';
      this.errors = errors;
    }
  }
}
</script>

<style>
.register-box {
  max-width: 500px;
  margin: 0 auto;
  margin-bottom: 60px;
  border: 1px solid #ccc;
  border-radius: 30px;
}

.register-box--header {
  font-weight: bold;
  padding: 15px;
  border-bottom: 1px solid #ccc;
}

.register-box--form {
  padding: 15px;
}

.register-box--form--row {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  justify-content: flex-start;
  padding-bottom: 15px;
}

.register-box--form--row-actions {
  justify-content: center;
}

.register-box--label {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: flex-start;
  flex: 1;
  font-size: 18;
  line-height: 24px;
}

.register-box--error {
  text-align: left;
  margin-top: 10px;
  color: red;
}

.register-box--text-input {
  padding: 5px;
  font-size: 18;
  line-height: 24px;
  flex: 1;
  margin-left: 15px;
}

.button {
  padding: 0;
  margin: 0;
  display: block;
  background-color: transparent;
  border: none;
  padding: 15px;
  font-size: 18px;
  line-height: 24px;
  background-color: #008ecc;
  border-radius: 10px;
  cursor: pointer;
  color: #fff;
}
</style>
